<script setup lang="ts">
import { computed, onMounted, ref } from 'vue'
import ErrorLoginDialog from './ErrorLoginDialog.vue'
import LoginDialog from './LoginDialog.vue'

type Material = {
  id: number
  name: string
  price: number
  quantity: number
  value: number
  stock: boolean
}

const page = ref(1)
const itemsPerPage = ref<any>(8)
// const dialog = ref(false)

const material = ref<Material[]>([])
const headers = [
  {
    title: 'Id',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Quantity',
    key: 'quantity',
    value: 'quantity'
  },
  {
    title: 'Stock',
    key: 'stock',
    value: 'stock'
  }
]

function initialize() {
  material.value = [
    {
      id: 1,
      name: 'Sugar',
      price: 46.0,
      quantity: 10,
      value: 0,
      stock: true
    },
    {
      id: 2,
      name: 'Honey',
      price: 38.0,
      quantity: 6,
      value: 0,
      stock: true
    },
    {
      id: 3,
      name: 'Green tea powder',
      price: 73.0,
      quantity: 8,
      value: 0,
      stock: true
    },
    {
      id: 4,
      name: 'Dough',
      price: 33.0,
      quantity: 12,
      value: 0,
      stock: true
    },
    {
      id: 5,
      name: 'Coffee Beans',
      price: 189.0,
      quantity: 6,
      value: 0,
      stock: true
    },
    {
      id: 6,
      name: 'Whipped Cream',
      price: 125.0,
      quantity: 4,
      value: 0,
      stock: true
    },
    {
      id: 7,
      name: 'Syrup',
      price: 190.0,
      quantity: 8,
      value: 0,
      stock: true
    },
    {
      id: 8,
      name: 'cocoa powder',
      price: 140.0,
      quantity: 0,
      value: 0,
      stock: true
    },
    {
      id: 9,
      name: 'Condensed Milk',
      price: 27.0,
      quantity: 10,
      value: 0,
      stock: true
    },
    {
      id: 10,
      name: 'Milk',
      price: 37.0,
      quantity: 0,
      value: 0,
      stock: true
    }
  ]
}
onMounted(() => {
  initialize()
})

const formattedMaterials = computed(() =>
  material.value.map((product) => ({
    ...product,
    price: product.price.toFixed(2),
    value: (product.price * product.quantity).toFixed(2)
  }))
)
const OutofStock = computed(() =>
  formattedMaterials.value.filter((product) => product.quantity === 0)
)
</script>

<template>
  <v-card elevation="3" class="mb-3" style="height: 485px">
    <v-carousel hide-delimiters>
      <!-- First Carousel Item -->
      <v-carousel-item src="./img/bg/coffee-shop-background.jpg" cover>
        <v-row
          align="center"
          justify="center"
          class="fill-height"
          style="backdrop-filter: blur(2px)"
        >
          <v-col align="center">
            <h1>HOME</h1>
          </v-col>
        </v-row>
      </v-carousel-item>

      <!-- Second Carousel Item -->
      <v-carousel-item src="./img/bg/cup.jpg" cover>
        <v-row
          align="center"
          justify="center"
          class="fill-height"
          style="backdrop-filter: blur(2px)"
        >
          <v-col align="center">
            <h1>MAKE COFFEE</h1>
          </v-col>
        </v-row>
      </v-carousel-item>

      <!-- Third Carousel Item -->
      <v-carousel-item src="./img/bg/rustic.jpg" cover>
        <v-row
          align="center"
          justify="center"
          class="fill-height"
          style="backdrop-filter: blur(2px)"
        >
          <v-col align="center">
            <h1>MAKE YOU HAPPY</h1>
          </v-col>
        </v-row>
      </v-carousel-item>
    </v-carousel>
  </v-card>
  <v-card elevation="3" class="mb-3">
    <v-row>
      <v-col>
        <v-card-title style="color: rgb(0, 0, 0); text-align: center"
          >POPULAR PRODUCTS</v-card-title
        >
        <v-container style="width: 320px; height: 240px; border-radius: 5%"
          ><v-row>
            <v-col>
              <v-sheet class="sheet">
                <v-img src="/img/coffee/product2.png"></v-img>
                <v-app-bar-title style="font-size: small"> Cappuchino </v-app-bar-title>
              </v-sheet>
            </v-col>
            <v-col>
              <v-sheet class="sheet">
                <v-img src="/img/coffee/product5.png"></v-img>
                <v-app-bar-title style="font-size: small"> Chocolate </v-app-bar-title>
              </v-sheet>
            </v-col>
            <v-col>
              <v-sheet class="sheet">
                <v-img src="/img/coffee/product6.png"></v-img>
                <v-app-bar-title style="font-size: small"> Amaricano </v-app-bar-title>
              </v-sheet>
            </v-col>
          </v-row>
          <br />
          <v-row>
            <v-col>
              <v-sheet class="sheet">
                <v-img src="/img/coffee/product4.png"></v-img>
                <div style="text-align: center; font-size: smaller">Coacoa</div>
              </v-sheet>
            </v-col>
            <v-col>
              <v-sheet class="sheet">
                <v-img src="/img/coffee/product18.png"></v-img>
                <div style="text-align: center; font-size: smaller">Coffee cake</div>
              </v-sheet>
            </v-col>

            <v-col>
              <v-sheet class="sheet">
                <v-img src="/img/coffee/product11.png"></v-img>
                <div style="text-align: center; font-size: smaller">Brownie</div>
              </v-sheet>
            </v-col>
          </v-row>
        </v-container>
      </v-col>
      <v-divider vertical></v-divider>
      <!-- unpopular products -->
      <v-col>
        <v-card-title style="color: rgb(0, 0, 0); text-align: center"
          >UNPOPULAR PRODUCTS</v-card-title
        >
        <v-container style="width: 320px; height: 240px; border-radius: 5%">
          <v-row>
            <v-col>
              <v-sheet class="sheet">
                <v-img src="/img/coffee/product23.png"></v-img>
                <div style="text-align: center; font-size: smaller">Mango cake</div>
              </v-sheet>
            </v-col>
            <v-col>
              <v-sheet class="sheet">
                <v-img src="/img/coffee/product7.png"></v-img>
                <div style="text-align: center; font-size: smaller">Matcha Latte</div>
              </v-sheet>
            </v-col>
            <v-col>
              <v-sheet class="sheet">
                <v-img src="/img/coffee/product19.png"></v-img>
                <div style="text-align: center; font-size: smaller">Orange cake</div>
              </v-sheet>
            </v-col>
          </v-row>
          <br />
          <v-row> </v-row
        ></v-container>
      </v-col>
      <v-divider vertical></v-divider>
      <!-- Out of stock -->
      <v-col>
        <v-card-title style="color: rgb(0, 0, 0); text-align: center">OUT OF STOCK</v-card-title>
        <v-data-table-virtual
          v-model:page="page"
          :headers="headers"
          :items="OutofStock"
          :items-per-page="itemsPerPage"
        >
          <template v-slot:[`item.stock`]="{ item }">
            <div class="text-left">
              <v-chip
                :color="item.quantity > 0 ? 'green' : 'red'"
                :text="item.quantity > 0 ? 'In stock' : 'Out of stock'"
                class="text-uppercase"
                label
                size="small"
              ></v-chip>
            </div>
          </template>
        </v-data-table-virtual>
      </v-col>
    </v-row>
  </v-card>
  <ErrorLoginDialog></ErrorLoginDialog>
  <LoginDialog></LoginDialog>
</template>
<style scoped>
div {
  font-family: 'Kanit';
}

.sheet {
  width: 80px;
  height: 80px;
  border-radius: 50%;
}

h1 {
  color: white;
  font-size: 150px;
  letter-spacing: calc(1em / 16);
  -webkit-text-fill-color: transparent;
  -webkit-text-stroke-width: 0.1px;
}
</style>
